/*
 * MosP - Mind Open Source Project         http://www.mosp.jp/
 * Copyright (C) 1987-2008 MIND Co., Ltd.  http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.system.action;

import jp.mosp.common.CommonConst;
import jp.mosp.common.action.MosPAction;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;
import jp.mosp.system.dao.MYakusyokuDao;
import jp.mosp.system.dto.MYakusyokuDto;
import jp.mosp.system.vo.YakusyokuMasterCardVo;

public class YakusyokuMasterCardAction extends MosPAction {

	// コマンド
	private static final String CMD_YAKUSYOKU_MASTER_CARD_SHOW   = "S2205";	// 表示(追加)
	private static final String CMD_YAKUSYOKU_MASTER_CARD_SELECT = "S2206";	// 表示(選択)
	private static final String CMD_YAKUSYOKU_MASTER_CARD_INSERT = "S2207";	// 登録
	private static final String CMD_YAKUSYOKU_MASTER_CARD_UPDATE = "S2208";	// 更新
	private static final String CMD_YAKUSYOKU_MASTER_CARD_DELETE = "S2209";	// 削除

	/**
	 * コンストラクタ
	 */
	public YakusyokuMasterCardAction() {
		super();
	}

	public void action() throws Exception {
		// DBコネクション取得
		getConnection();
		// SYSTEM権限確認
		confirmSystemAuth();
		// VOの取得及び設定
		YakusyokuMasterCardVo vo = new YakusyokuMasterCardVo();
		vo.initVo(cfg, msg, cmd, aspUser, user);
		vo.setParams(request);
		// VO及びフォワード先URLの設定
		setVo(vo);
		setUrl(vo.getRetUrl());
		// DAOの準備
		MYakusyokuDao dao;
		dao = new MYakusyokuDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		// 等級区分プルダウンリスト作成
		vo.aryPltTokyu = getMosPCodeArray(CommonConst.TID_GRADE);
		// 役職手当区分プルダウンリスト（有無＋給与情報単価）作成
		vo.aryPltExistence1 = getPositionAllowanceType1();
		// 役職手当区分プルダウンリスト（有無＋固定単価）作成
		vo.aryPltExistence2 = getPositionAllowanceType2();
		// 役職手当区分プルダウンリスト（有無＋給与情報単価＋固定単価）作成
		vo.aryPltExistence3 = getPositionAllowanceType3();
		// 手当名称リスト作成
		vo.aryAllowance = getMosPCodeArray(CommonConst.TID_ALLOWANCE_NAME);
		// DTOの取得
		MYakusyokuDto dto;
		Object obj = session.getAttribute(MospConst.ATT_DTO);
		dto = obj instanceof MYakusyokuDto ? (MYakusyokuDto)obj : null;
		// コマンド毎の処理
		if (cmd.equals(CMD_YAKUSYOKU_MASTER_CARD_SHOW)) {
			vo.setDefaultValues();
			vo.setMode(YakusyokuMasterCardVo.MODE_INSERT);
		} else if (cmd.equals(CMD_YAKUSYOKU_MASTER_CARD_SELECT)) {
			// 表示(キーで情報を検索)
			// データの取得
			dto = dao.findForKey(key1, key2);
			chkExist(dto);
			// VOに情報をセット
			vo.setFields(dto);
			setMode(vo);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);			
		} else if (cmd.equals(CMD_YAKUSYOKU_MASTER_CARD_INSERT)) {
			// 新規登録
			dto = insert(vo);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);			
		} else if (cmd.equals(CMD_YAKUSYOKU_MASTER_CARD_UPDATE)) {	
			// 更新
			dto = update(vo, dto);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);			
		} else if (cmd.equals(CMD_YAKUSYOKU_MASTER_CARD_DELETE)) {
			// 削除
			delete(vo,dto);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);			
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}

	/**
	 * データ挿入
	 * @param vo 対象VO
	 * @return データ挿入対象DTO
	 * @throws Exception
	 */
	private MYakusyokuDto insert(YakusyokuMasterCardVo vo) throws Exception {
		// パラメータの妥当性確認
		vo.validate();
		// DAOの準備
		MYakusyokuDao dao = new MYakusyokuDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		// 存在チェック
		chkDuplicate(dao.findForKey(vo.getTxtYCode(), vo.getPltTokyu()), vo);
		// DTOの準備
		MYakusyokuDto dto = new MYakusyokuDto();
		vo.setDtoFields(dto);
		// データの挿入
		dao.insert(dto);
		// DTOの再取得
		MYakusyokuDto retDto = dao.findForKey(dto.getYCode(), dto.getTokyu());
		chkInsert(retDto);
		// 等級無しの存在を確認
		if (!chkExistDto(dao.findForKey(vo.getTxtYCode(), CommonConst.NAM_COMMON_INTEGER_INITIAL_VALUE))) {
			MYakusyokuDto nonGradeDto = dto;
			nonGradeDto.setTokyu(CommonConst.NAM_COMMON_INTEGER_INITIAL_VALUE);
			// データの挿入		
			dao.insert(nonGradeDto);
			// DTOの再取得
			nonGradeDto = dao.findForKey(nonGradeDto.getYCode(), nonGradeDto.getTokyu());
			chkInsert(nonGradeDto);
		}
		// コミット
		commit();
		// モード設定
		setMode(vo);
		// メッセージ設定
		vo.setMessage(MospUtility.getMessage(msg, MospConst.MSG_INSERT, ""));
		return retDto;
	}

	/**
	 * データ更新
	 * @param vo 対象VO
	 * @param dto 対象DTO
	 * @return データ挿入対象DTO
	 * @throws Exception
	 */
	private MYakusyokuDto update(YakusyokuMasterCardVo vo, MYakusyokuDto dto) throws Exception {
		// 等級区分取得
		vo.setPltTokyu(dto.getTokyu());
		// パラメータの妥当性確認
		vo.validate();
		// DAOの準備
		MYakusyokuDao dao = new MYakusyokuDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		// 排他確認
		chkExclusive(dto, dao.findForUpdate(vo.getTxtYCode(), vo.getPltTokyu()), vo);
		// DTOの準備
		vo.setDtoFields(dto);
		// データの更新
		dao.update(dto);
		// DTOの再取得
		MYakusyokuDto retDto = dao.findForKey(dto.getYCode(), dto.getTokyu());
		chkUpdate(retDto);
		// コミット
		commit();
		// モード設定
		setMode(vo);
		// メッセージ設定
		vo.setMessage(MospUtility.getMessage(msg, MospConst.MSG_UPDATE, ""));
		return retDto;
	}

	/**
	 * データ削除
	 * @param vo 対象VO
	 * @param dto 対象DTO
	 * @throws Exception
	 */
	private void delete(YakusyokuMasterCardVo vo,MYakusyokuDto dto) throws Exception {
		// 等級区分取得
		vo.setPltTokyu(dto.getTokyu());
		// DAOの準備
		MYakusyokuDao dao = new MYakusyokuDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		// データの更新
		dao.delete(dto);
		// コミット
		commit();
		// メッセージ設定
		vo.setMessage(MospUtility.getMessage(msg, MospConst.MSG_DELETE, ""));
	}

	/**
	 * モード設定
	 * @param vo 対象VO
	 * @throws Exception
	 */
	private void setMode(YakusyokuMasterCardVo vo) throws Exception {
		// モード設定
		if (hasSystemAuth()) {
			vo.setMode(YakusyokuMasterCardVo.MODE_SYSTEM);
		} else {
			vo.setMode(YakusyokuMasterCardVo.MODE_UPDATE);
		}
	}

}
